# -*- coding: utf-8 -*-
from __future__ import print_function

import sys
from PyQt5.QtWidgets import QMainWindow, QApplication, QPushButton, QWidget, QAction, QTabWidget,QVBoxLayout,QMessageBox,QLineEdit
from PyQt5.QtWidgets import QLabel, QComboBox , QGridLayout , QSlider ,QSpinBox,QDoubleSpinBox, QToolTip,QPlainTextEdit,QFormLayout,QFileDialog
from PyQt5.QtGui import QIcon, QFont    
from PyQt5.QtCore import Qt
from PyQt5.QtCore import pyqtSlot

#imports

from sklearn.feature_extraction.text import TfidfVectorizer
from sklearn.feature_extraction.text import CountVectorizer
import pandas as pd 
import numpy as np


from sklearn.metrics import make_scorer
from sklearn.metrics import roc_curve, auc
from sklearn.metrics import explained_variance_score
from sklearn.model_selection import cross_val_score
from sklearn.model_selection import ShuffleSplit
from sklearn.model_selection import StratifiedShuffleSplit


from sklearn.naive_bayes import MultinomialNB 
from sklearn.neighbors import KNeighborsClassifier
from sklearn.calibration import CalibratedClassifierCV
from sklearn.neural_network import MLPClassifier


from sklearn.svm import LinearSVC
from nltk.stem import PorterStemmer
from nltk import word_tokenize
from sklearn.cross_validation import train_test_split
from sklearn.pipeline import Pipeline
from nltk.corpus import stopwords
from sklearn.model_selection import GridSearchCV
from sklearn.model_selection import cross_val_predict

from sklearn.metrics import roc_curve, auc
#import matplotlib.pyplot as plt
#import nltk
#nltk.download('punkt')

from pprint import pprint
from time import time
import logging

import math
import csv
import re
import string
import random
import unicodedata
import sys
import codecs


#reload(sys)
#sys.setdefaultencoding('utf8')
from pyspark import SparkContext

 
class App(QMainWindow):
 
    def __init__(self):
        super().__init__()
        self.title = 'Análisis de Sentimiento'
        self.left = 0
        self.top = 0
        self.width = 700
        self.height = 700
        self.setWindowTitle(self.title)
        self.setGeometry(self.left, self.top, self.width, self.height)
 
        self.table_widget = MyTableWidget(self)
        self.setCentralWidget(self.table_widget)
 
        self.show()
 
class MyTableWidget(QWidget):        
 
    def __init__(self, parent):   
        super(QWidget, self).__init__(parent)
        self.layout = QVBoxLayout(self)
 
        #mensajes
        QToolTip.setFont(QFont('SansSerif', 10))
        
        # Initialize tab screen
        self.tabs = QTabWidget()
        self.tab1 = QWidget()	
        self.tab2 = QWidget()
        self.tab3 = QWidget()
        self.tab4 = QWidget()
        self.tab5 = QWidget()
        self.tab6 = QWidget()
        self.tab7 = QWidget()
        self.tab8 = QWidget()
        
        
        
        
        self.tabs.resize(300,200) 
 
        # Add tabs
        self.tabs.addTab(self.tab5,"Etiquetado")
        self.tabs.addTab(self.tab1,"Preprocesado")
        self.tabs.addTab(self.tab4,"Vectorizer")
        self.tabs.addTab(self.tab8,"Selección de Modelo")#Modelos
        self.tabs.addTab(self.tab6,"Evaluar Modelo")#Clasificación Final
         
        self.file = QFileDialog()
        
        # Create tab5 Pestaña de definición del etiquetado##################################################################################
        #Campos de la pestaña
        #self.titulot5rt = QLabel('Ruta del fichero a etiquetar:')
        #self.titulot5rt.setToolTip('Introduce la ruta del fichero')
        #ficheros
        
        
        self.textot5rt = QLineEdit()
        self.textot5rt.setText("datasets/SentimentAnalysisDataset1-2.csv")#para pruebas
        self.pushButtont5fl = QPushButton("Selecciona Fichero")
        self.pushButtont5fl.clicked.connect(self.urlEtiquetado)
        
        self.textot5ps = QLineEdit()
        self.textot5ps.setText("diccionarios/positive-words.txt")#para pruebas
        self.pushButtont5ps = QPushButton("Diccionario positivos")
        self.pushButtont5ps.clicked.connect(self.posEtiquetado)
        
        self.textot5ng = QLineEdit()
        self.textot5ng.setText("diccionarios/negative-words.txt")#para pruebas
        self.pushButtont5ng = QPushButton("Diccionario negativos")
        self.pushButtont5ng.clicked.connect(self.negEtiquetado)
               
        self.titulot5bn = QLabel('Categorías')
        self.combot5bn = QComboBox(self)
        self.combot5bn.addItems(["Binario","Ternario"])
        
        self.titulot5sp = QLabel('Separador')
        self.textot5sp = QLineEdit()
        self.textot5sp.setText(";")#para pruebas
    
        self.pushButtont5et = QPushButton("Etiquetar")
        self.pushButtont5et.clicked.connect(self.etiquetadoButton)
        
        self.pushButtont5sv = QPushButton("Guardar")
        self.pushButtont5sv.clicked.connect(self.guardaEtiquetado)
        self.textot5sv = QLineEdit()
        self.textot5sv.setText("etiquetado.csv")#para pruebas
         
        self.titulot5tx = QLabel('Campo Texto')
        self.sptt5tx = QSpinBox()
        self.sptt5tx.setRange(0,1000)
        self.sptt5tx.setSingleStep(1)
        
        self.titulot5rs = QLabel('LOG')
        self.resultadost5 = QPlainTextEdit('Estado: No Iniciado\n')#'Estado: NO INICIADO'
        self.resultadost5.setReadOnly(True)

        
        #Gestión del grid
        self.gridt5 = QGridLayout()
        self.gridt5.addWidget(self.pushButtont5fl, 1, 0)
        self.gridt5.addWidget(self.textot5rt, 1, 1)
        self.gridt5.addWidget(self.pushButtont5ps, 2, 0)
        self.gridt5.addWidget(self.textot5ps, 2, 1)
        self.gridt5.addWidget(self.pushButtont5ng, 3, 0)
        self.gridt5.addWidget(self.textot5ng, 3, 1)
        self.gridt5.addWidget(self.titulot5bn, 4, 0)
        self.gridt5.addWidget(self.combot5bn, 4, 1)
        self.gridt5.addWidget(self.titulot5sp, 5, 0)
        self.gridt5.addWidget(self.textot5sp, 5, 1)
        self.gridt5.addWidget(self.titulot5tx, 6, 0)
        self.gridt5.addWidget(self.sptt5tx, 6, 1)
        self.gridt5.addWidget(self.pushButtont5et, 7,1)
        self.gridt5.addWidget(self.pushButtont5sv, 8, 0)
        self.gridt5.addWidget(self.textot5sv, 8, 1)
        self.gridt5.addWidget(self.titulot5rs,9,0)
        self.gridt5.addWidget(self.resultadost5,9,1)
        
		#Gestión de la pestaña
        self.tab5.layout = QVBoxLayout(self)
        self.tab5.setLayout(self.gridt5)
        
      
        # Create first tab Pestaña de preprocesado de texto##################################################################################        
        #Campos de la pestaña
        self.pushButtont1fl = QPushButton("Selecciona Fichero")
        self.pushButtont1fl.clicked.connect(self.urlPreprocesado)
        self.textot1rt = QLineEdit()
        self.textot1rt.setText("etiquetados/etiquetado.csv")#para pruebas
        
        self.titulot1tt = QLabel('Preprocesado de texto')
        self.titulot1tw = QLabel('Preprocesado de Twitter')
        self.combot1tw = QComboBox(self)
        self.combot1tw.addItems(["SI","NO"])
        self.combot1tt = QComboBox(self)
        self.combot1tt.addItems(["SI","NO"])
        self.pushButtont1 = QPushButton("Procesar")
        self.pushButtont1.clicked.connect(self.preprocesadoButton)

        self.titulot1rs = QLabel('LOG')
        self.resultadost1 = QPlainTextEdit('ESTADO: No Iniciado\n')#'Estado: NO INICIADO'
        self.resultadost1.setReadOnly(True)
        #self.titulot1st = QLabel('Estado: NO INICIADO')
        
        self.titulot1sp = QLabel('Separador')
        self.textot1sp = QLineEdit()
        self.textot1sp.setText(";")#para pruebas
        
        self.titulot1et = QLabel('Campo Etiqueta')
        self.sptt1et = QSpinBox()
        self.sptt1et.setRange(0,1000)
        self.sptt1et.setSingleStep(1)
        
        self.titulot1ct = QLabel('Campo Tweet')
        self.sptt1ct = QSpinBox()
        self.sptt1ct.setRange(0,1000)
        self.sptt1ct.setSingleStep(1)
        
        self.titulot1tst = QLabel('Test partition')
        self.sptt1tst = QDoubleSpinBox()
        self.sptt1tst.setRange(0,1)
        self.sptt1tst.setDecimals(2)
        self.sptt1tst.setSingleStep(0.01)
        
        self.pushButtont1sv = QPushButton("Guardar")
        self.pushButtont1sv.clicked.connect(self.guardaPreprocesado)
        self.textot1sv = QLineEdit()
        self.textot1sv.setText("preprocesado.csv")#para pruebas
        
		#Gestión del grid
        self.gridt1 = QGridLayout()
        self.gridt1.setSpacing(10)
        
        #self.gridt1.addWidget(self.titulot1rt, 1, 0)
        self.gridt1.addWidget(self.pushButtont1fl, 1, 0)
        self.gridt1.addWidget(self.textot1rt, 1, 1)
        self.gridt1.addWidget(self.titulot1tt, 2, 0)
        self.gridt1.addWidget(self.combot1tt, 2, 1)
        self.gridt1.addWidget(self.titulot1tw, 3, 0)
        self.gridt1.addWidget(self.combot1tw, 3, 1)
        self.gridt1.addWidget(self.titulot1sp, 4, 0)
        self.gridt1.addWidget(self.textot1sp, 4, 1)
        self.gridt1.addWidget(self.titulot1et, 5, 0)
        self.gridt1.addWidget(self.sptt1et, 5, 1)
        self.gridt1.addWidget(self.titulot1ct, 6, 0)
        self.gridt1.addWidget(self.sptt1ct, 6, 1)
        self.gridt1.addWidget(self.titulot1tst, 7, 0)
        self.gridt1.addWidget(self.sptt1tst, 7, 1)
        self.gridt1.addWidget(self.pushButtont1, 8,1)
        self.gridt1.addWidget(self.pushButtont1sv, 9,0)
        self.gridt1.addWidget(self.textot1sv, 9,1)
        self.gridt1.addWidget(self.titulot1rs, 10,0)
        self.gridt1.addWidget(self.resultadost1, 10,1)
        
		#Gestión del tab
        self.tab1.layout = QVBoxLayout(self)
        self.tab1.setLayout(self.gridt1)
        #self.tab1.setLayout(self.tab1.layout)
       
       
        #fourth  tab####################################################################################################################################################################
        #parmatros vectorizer
        #Campos de la pestaña
        self.titulot4st = QLabel('Stemmer')
        self.combot4st = QComboBox(self)
        self.combot4st.addItems(["True","False"])
              
        self.titulot4sw = QLabel('StopWords')
        self.combot4sw = QComboBox(self)
        self.combot4sw.addItems(["True","False"])        
        
        self.titulot4max_df = QLabel('max_df')
        self.sptt4max_df = QDoubleSpinBox()
        self.sptt4max_df.setRange(0.01,1.0)
        self.sptt4max_df.setDecimals(2)
        self.sptt4max_df.setSingleStep(0.01)
               
        self.titulot4min_df = QLabel('min_df')
        self.sptt4min_df = QSpinBox()
        self.sptt4min_df.setRange(1,50)
        self.sptt4min_df.setSingleStep(1)
        
        self.titulot4idf = QLabel('Use Idf')
        self.combot4idf= QComboBox(self)
        self.combot4idf.addItems(["True","False"])
        
        self.titulot4sb = QLabel('Sublinear TF')
        self.combot4sb= QComboBox(self)
        self.combot4sb.addItems(["True","False"])
        
        self.titulot4ng = QLabel('N-gramas')
        self.sptt4ng = QSpinBox()
        self.sptt4ng.setRange(1,50)
        self.sptt4ng.setSingleStep(1)
        
        self.titulot4ft = QLabel('Max Features')
        self.sptt4ft = QSpinBox()
        self.sptt4ft.setRange(0,50)
        self.sptt4ft.setSingleStep(1)
        
        self.pushButtont4 = QPushButton("Parametros Modelo")
        self.pushButtont4.clicked.connect(self.saltoParametrizacion)
        
        #Gestión del grid
        self.gridt4 = QGridLayout()
        self.gridt4.setSpacing(10)
        self.gridt4.addWidget(self.titulot4st, 1, 0)
        self.gridt4.addWidget(self.combot4st, 1, 1)
        self.gridt4.addWidget(self.titulot4sw, 2, 0)
        self.gridt4.addWidget(self.combot4sw, 2, 1)
        self.gridt4.addWidget(self.titulot4min_df, 3, 0)
        self.gridt4.addWidget(self.sptt4min_df, 3, 1)
        self.gridt4.addWidget(self.titulot4max_df, 4, 0)
        self.gridt4.addWidget(self.sptt4max_df, 4, 1)
        self.gridt4.addWidget(self.titulot4idf, 5, 0)
        self.gridt4.addWidget(self.combot4idf, 5, 1)
        self.gridt4.addWidget(self.titulot4sb, 6, 0)
        self.gridt4.addWidget(self.combot4sb, 6, 1)
        self.gridt4.addWidget(self.titulot4ng, 7, 0)
        self.gridt4.addWidget(self.sptt4ng, 7, 1)
        self.gridt4.addWidget(self.titulot4ft, 8, 0)
        self.gridt4.addWidget(self.sptt4ft, 8, 1)
       
        
        self.gridt4.addWidget(self.pushButtont4, 9, 1)
        
		#Gestión de la pestaña
        self.tab4.layout = QVBoxLayout(self)
        self.tab4.setLayout(self.gridt4)
        #self.tab4.setLayout(self.tab4.layout)
        
        # Create tab6 tab Pestaña de procesado del classificador - el procesado se realiza en clasificacionButton##################################################################################
        #Campos de la pestaña
        self.tab6.layout = QVBoxLayout(self)
        #self.tab3.setLayout(self.tab3.layout)
        self.formt6 = QFormLayout()
        self.formt6.setSpacing(10)
        self.tab6.setLayout(self.formt6)
        self.combot6cs = QComboBox(self)
        self.combot6cs.addItems(["ConjuntoPruebaActual","CargaTest","ValidaciónCruzada","HoldOut"])
        self.pushButtont6 = QPushButton("SelecciónMétodoEvaluación")
        self.pushButtont6.clicked.connect(self.handleButtonCrearParametrosClasificacion)
        self.formt6.addRow(self.pushButtont6, self.combot6cs)
        
        self.titulot6rs = QLabel('LOG')
        self.resultadost6 = QPlainTextEdit('ESTADO: No Iniciado\n')
        self.resultadost6.setReadOnly(True)
        self.formt6.addRow(self.resultadost6)
        
        # Create tab8 tab Pestaña de final##################################################################################
        #Campos de la pestaña
        self.tab8.layout = QVBoxLayout(self)
        #self.tab3.setLayout(self.tab3.layout)
        self.formt8 = QFormLayout()
        self.formt8.setSpacing(10)
        self.tab8.setLayout(self.formt8)
        self.combot8cs = QComboBox(self)
        self.combot8cs.addItems(["ImportarModelo","Optimizador","Parametrizar"])
        self.pushButtont8 = QPushButton("SeleccionModo")
        self.pushButtont8.clicked.connect(self.handleButtonSeleccionModelo)
        self.formt8.addRow(self.pushButtont8, self.combot8cs)
        
        self.titulot8rs = QLabel('LOG')
        self.resultadost8 = QPlainTextEdit('ESTADO: No Iniciado\n')
        self.resultadost8.setReadOnly(True)
        self.formt8.addRow(self.resultadost8)
        
        
        # Add tabs to widget###################################################################################        
        self.layout.addWidget(self.tabs)
        self.setLayout(self.layout)
        
        
        #inicializacion de variables
        self.guardadoEt = False
        self.guardadoMd = False
        self.modeloActual = "Vacio" #tipo de modelo generado actualmente import/grid/model
        self.clasificadorTipo = "Vacio" # si se ha seleccionado una de las 3 funciones de seleccion de modelo
        self.clasificadorName = "Vacio" # si se ha elegido algoritmo de calsificacion
        self.clasificar=False #si esta preprocesado
        self.clasificarTipo="Vacio" #tipo de evaluacion elegida
        self.categorias="Vacio"#cantidad de categorias
        self.stopWords=['i', 'me', 'my', 'myself', 'we', 'our', 'ours', 'ourselves', 'yo', "yore", "yove", "yoll", 
                   "yo'd", 'your', 'yours', 'yourself', 'yourselves', 'he', 'him', 'his', 'himself', 'she', "she's", 
                   'her', 'hers', 'herself', 'it', 'its', 'itself', 'they', 'them', 'their', 'theirs', 'themselves', 
                   'what', 'which', 'who', 'whom', 'this', 'that', "thatll", 'these', 'those', 'am', 'is', 'are', 
                   'was', 'were', 'be', 'been', 'being', 'have', 'has', 'had', 'having', 'do', 'does', 'did', 'doing', 
                   'a', 'an', 'the', 'and', 'but', 'if', 'or', 'because', 'as', 'until', 'while', 'of', 'at', 'by', 'for', 
                   'with', 'about', 'against', 'between', 'into', 'through', 'during', 'before', 'after', 'above', 'below', 
                   'to', 'from', 'up', 'down', 'in', 'out', 'on', 'off', 'over', 'under', 'again', 'further', 'then', 'once', 
                   'here', 'there', 'when', 'where', 'why', 'how', 'all', 'any', 'both', 'each', 'few', 'more', 'most', 
                   'other', 'some', 'such', 'no', 'nor', 'not', 'only', 'own', 'same', 'so', 'than', 'too', 'very', 's', 
                   't', 'can', 'will', 'just', 'don', "dont", 'should', "shouldve", 'now', 'd', 'll', 'm', 'o', 're', 
                   've', 'y', "nt"] #palabras de parada
                   
        ##################################################################...FUNCTIONS...#########################################################################
    
        
    #funcion para guardar el etiquetado en la ruta etiquetado que debe estar en el directorio de ejecución
    def guardaEtiquetado(self):
        print('guardaretiquetado')
        if self.guardadoEt == True:
            import numpy as np
            nombreGuardado = "etiquetados/"+self.textot5sv.text()
            np.savetxt(nombreGuardado, self.outputEtiquetado, fmt='%s',delimiter=';')
            self.resultadost5.appendPlainText('ESTADO: Guardado\n')
        else:
            self.resultadost5.appendPlainText('ESTADO: Etiqueta primero\n')
     
     
    #funcion para guardar el preprocesado en la ruta preprocesados que debe estar en el directorio de ejecución
    def guardaPreprocesado(self):
        print('guardaPreprocesado')
        if self.clasificar == True:
            import numpy as np
            output=[]
            nombreGuardado = "preprocesados/"+self.textot1sv.text()
            for index in range(len(self.corpus)):               
                output.append([self.corpusSent[index],self.corpus[index]])
            np.savetxt(nombreGuardado, output, fmt='%s',delimiter=';')
            self.resultadost1.appendPlainText('ESTADO: Guardado\n')
        else:
            self.resultadost1.appendPlainText('ESTADO: Preprocesa primero\n')
            
                  
    #funcion para guardar el modelo generado
    def guardaModelo(self):
        print('guardarModelo')
        if self.modeloActual != "Vacio": 
            nombreGuardado = "modelos/"+self.textot8sv.text()
            from sklearn.externals import joblib
            #import dill as pickle
            #import cPickle as pickle
            #pickle.dumps(self.modelo, nombreGuardado)
            if self.modeloActual == "optimizado":
                joblib.dump(self.grid_search, nombreGuardado)
            elif self.modeloActual == "generado":
                joblib.dump(self.modelo, nombreGuardado)
            elif self.modeloActual == "importado":
                joblib.dump(self.pipelineImport, nombreGuardado)
    
            self.resultadost8.appendPlainText('ESTADO: Guardado\n')
        else:
            self.resultadost8.appendPlainText('ESTADO: Genera primero el Modelo\n')      
            
        
    #Funciones para extraer la ruta de los ficheros
    def urlEtiquetado(self):
		#url de etiquetado
        self.textot5rt.setText(self.file.getOpenFileName(self,'Select File')[0])
    def urlPreprocesado(self):
		#url de preprocesado
        self.textot1rt.setText(self.file.getOpenFileName(self,'Select File')[0])
	
    def posEtiquetado(self):
		#url de diccionario positivo
        self.textot5ps.setText(self.file.getOpenFileName(self,'Select File')[0])
    def negEtiquetado(self):
		#url de diccionario negativo
        self.textot5ng.setText(self.file.getOpenFileName(self,'Select File')[0])
        
    def testPreprocesado(self):
		#url de preprocesado
        self.textot6pp.setText(self.file.getOpenFileName(self,'Select File')[0])
        
    def importarModelo(self):
		#url de importar modelo
        self.textot8im.setText(self.file.getOpenFileName(self,'Select File')[0])
    
    #Funciones de cambio de pestaña
    def saltoClasificador(self):
		#cambio a la pestaña Crear Modelo
        self.tabs.setCurrentIndex(4)
        #self.modeloActual = "parametrizar"
        
    def saltoParametrizacion(self):
		#cambio a la pestaña Parametrizacion
        self.tabs.setCurrentIndex(3)
                
    #funcion que carga los parametros de cada opcion dependiendo del combobox
    def handleButtonSeleccionModelo(self):
        entrada = str(self.combot8cs.currentText())
        numRows=self.formt8.rowCount()
        for i in range(numRows):
            self.formt8.removeRow(0)
        
        self.combot8cs = QComboBox(self)
        
        if (entrada == "ImportarModelo"):
            self.combot8cs.addItems(["ImportarModelo","Optimizador","Parametrizar"])
            self.pushButtont8 = QPushButton("SeleccionModo")
            self.pushButtont8.clicked.connect(self.handleButtonSeleccionModelo)
            self.formt8.addRow(self.pushButtont8, self.combot8cs)
            self.clasificadorTipo="ImportarModelo"
            print(self.clasificadorTipo)
            
            self.textot8im = QLineEdit()
            self.textot8im.setText("modelos/modelo.plk")#para pruebas
            self.pushButtont8im = QPushButton("Importar Modelo")
            self.pushButtont8im.clicked.connect(self.importarModelo)
            self.formt8.addRow(self.pushButtont8im, self.textot8im)
            
            self.pushButtont8o = QPushButton("ImportarModelo")
            self.pushButtont8o.clicked.connect(self.importarModeloClasificacion)
            self.formt8.addRow(self.pushButtont8o)
            
            self.pushButtont8sv = QPushButton("Guardar")
            self.pushButtont8sv.clicked.connect(self.guardaModelo)
            self.textot8sv = QLineEdit()
            self.textot8sv.setText("modelo.plk")#para pruebas
            self.formt8.addRow(self.pushButtont8sv, self.textot8sv)
                    
        elif (entrada == "Optimizador"):
            self.combot8cs.addItems(["Optimizador","Parametrizar","ImportarModelo"])
            self.pushButtont8 = QPushButton("SeleccionModo")
            self.pushButtont8.clicked.connect(self.handleButtonSeleccionModelo)
            self.formt8.addRow(self.pushButtont8, self.combot8cs)
            
            self.clasificadorTipo="Optimizador"
            print(self.clasificadorTipo)
            
            self.combot8cs2 = QComboBox(self)
            self.combot8cs2.addItems(["NaiveBayes","SVM","Kneighbors","MLPClassifier"])
            self.pushButtont8o = QPushButton("SelecciónAlgoritmo")
            self.pushButtont8o.clicked.connect(self.handleButtonCrearParametrosOptimos)
            self.formt8.addRow(self.pushButtont8o, self.combot8cs2)
            
        elif (entrada == "Parametrizar"):
        
            self.combot8cs.addItems(["Parametrizar","ImportarModelo","Optimizador"])
            self.pushButtont8 = QPushButton("SeleccionModo")
            self.pushButtont8.clicked.connect(self.handleButtonSeleccionModelo)
            self.formt8.addRow(self.pushButtont8, self.combot8cs)
            
            self.clasificadorTipo="Parametrizar"
            print(self.clasificadorTipo)
        
        
            self.combot8cs2 = QComboBox(self)
            self.combot8cs2.addItems(["NaiveBayes","SVM","Kneighbors","MLPClassifier"])
            self.pushButtont8o = QPushButton("SelecciónAlgoritmo")
            self.pushButtont8o.clicked.connect(self.handleButtonCrearParametros)
            self.formt8.addRow(self.pushButtont8o, self.combot8cs2)
            
        self.titulot8rs = QLabel('LOG')
        self.resultadost8 = QPlainTextEdit('ESTADO: No Iniciado\n')
        self.resultadost8.setReadOnly(True)
        self.formt8.addRow(self.resultadost8)
                      
       
       
                      
    #Recarga tab selccion de modelo con opcion optimos##########################################################
    def handleButtonCrearParametrosOptimos(self):
        entrada = str(self.combot8cs2.currentText())
        
        numRows=self.formt8.rowCount()
        for i in range(numRows):
            self.formt8.removeRow(0)
        
        
        self.combot8cs = QComboBox(self)
        self.combot8cs.addItems(["Optimizador","Parametrizar","ImportarModelo"])
        self.pushButtont8 = QPushButton("SeleccionModo")
        self.pushButtont8.clicked.connect(self.handleButtonSeleccionModelo)
        self.formt8.addRow(self.pushButtont8, self.combot8cs)
        self.clasificadorTipo="Optimizador"
        print(self.clasificadorTipo)
        
        self.combot8cs2 = QComboBox(self)
        self.pushButtont8o = QPushButton("CrearParametros")
        self.pushButtont8o.clicked.connect(self.handleButtonCrearParametrosOptimos)
        self.formt8.addRow(self.pushButtont8o, self.combot8cs2)
        
        #parametros vectorizer comunes    
        self.titulot8vt = QLabel('Vectorizer')
        self.formt8.addRow(self.titulot8vt)
        
        self.titulot8maxd = QLabel('max_df')
        self.textot8maxd = QLineEdit()
        self.textot8maxd.setText("0.5;0.8")#para pruebas   
        self.formt8.addRow(self.titulot8maxd, self.textot8maxd)
        
        self.titulot8mind = QLabel('min_df')
        self.textot8mind = QLineEdit()
        self.textot8mind.setText("5;10")#para pruebas   
        self.formt8.addRow(self.titulot8mind, self.textot8mind)
        
        self.titulot8maxf = QLabel('max_features')
        self.textot8maxf = QLineEdit()
        self.textot8maxf.setText("1000;5;None")#para pruebas   
        self.formt8.addRow(self.titulot8maxf, self.textot8maxf)
        
        self.titulot8ng = QLabel('N-gramas')
        self.textot8ng = QLineEdit()
        self.textot8ng.setText("1;2;3")#para pruebas   
        self.formt8.addRow(self.titulot8ng, self.textot8ng)
        
        self.titulot8st = QLabel('StopWords')
        self.combot8st = QComboBox(self)
        self.combot8st.addItems(["SI","NO"])
        self.formt8.addRow(self.titulot8st, self.combot8st)
        
        self.titulot8tk = QLabel('Stemmer')
        self.combot8tk = QComboBox(self)
        self.combot8tk.addItems(["SI","NO"])
        self.formt8.addRow(self.titulot8tk, self.combot8tk)
        
        self.titulot8idf = QLabel('Use IDF')
        self.combot8idf= QComboBox(self)
        self.combot8idf.addItems(["SI","NO"])
        self.formt8.addRow(self.titulot8idf, self.combot8idf)
        
        self.titulot8utf = QLabel('Sublinear TF')
        self.combot8utf= QComboBox(self)
        self.combot8utf.addItems(["SI","NO"])
        self.formt8.addRow(self.titulot8utf, self.combot8utf)
        
        #parametros clasificador
        self.titulot8cl = QLabel('Clasificador')
        self.formt8.addRow(self.titulot8cl)

        if (entrada == "NaiveBayes"):
    
            self.combot8cs2.addItems(["NaiveBayes","SVM","Kneighbors","MLPClassifier"])
            self.clasificadorName="NB"
            print(self.clasificadorName)
                  
            self.textot8ap = QLineEdit()
            self.textot8ap.setText("0.00001;1.0;10.0")#para pruebas   
            self.titulot8ap = QLabel('Alpha')
            self.formt8.addRow(self.titulot8ap, self.textot8ap)
            
            self.titulot8fp = QLabel('Fit_Prior')
            self.combot8fp = QComboBox(self)
            self.combot8fp.addItems(["SI","NO"])
            self.formt8.addRow(self.titulot8fp, self.combot8fp)
                        
            
        elif (entrada == "SVM"):
            
            
            self.combot8cs2.addItems(["SVM","NaiveBayes","Kneighbors","MLPClassifier"])
            self.clasificadorName="SVM"
            print(self.clasificadorName)
              
            self.textot8c = QLineEdit()
            self.textot8c.setText("0.00001;10.0;0.1")#para pruebas   
            self.titulot8c = QLabel('C')
            self.formt8.addRow(self.titulot8c, self.textot8c)
            
            self.titulot8dl = QLabel('dual')
            self.combot8dl = QComboBox(self)
            self.combot8dl.addItems(["SI","NO"])
            self.formt8.addRow(self.titulot8dl, self.combot8dl)
            
            
        elif (entrada == "Kneighbors"):
            self.combot8cs2.addItems(["Kneighbors","SVM","NaiveBayes","MLPClassifier"])
            self.clasificadorName="KN"
            print(self.clasificadorName)
            
            self.textot8nv = QLineEdit()
            self.textot8nv.setText("1;10;50")#para pruebas   
            self.titulot8nv = QLabel('Nº Vecinos')
            self.formt8.addRow(self.titulot8nv, self.textot8nv)
        
        elif (entrada == "MLPClassifier"):
            self.titulot8hl = QLabel('Hidden Layers,Hidden Units')
            self.textot8hl = QLineEdit()
            self.textot8hl.setText("1,5;2,5,5")#para pruebas   
            self.formt8.addRow(self.titulot8hl, self.textot8hl)
            
            self.textot8am = QLineEdit()
            self.textot8am.setText("0.00001;1.0;10.0")#para pruebas   
            self.titulot8am = QLabel('Alpha')
            self.formt8.addRow(self.titulot8am, self.textot8am)
            
            self.titulot8it = QLabel('Nº Iteraciones')
            self.textot8it = QLineEdit()
            self.textot8it.setText("500;1000;5000")#para pruebas   
            self.formt8.addRow(self.titulot8it, self.textot8it)
            
            #constant’, ‘invscaling’, ‘adaptive
            self.titulot8lr = QLabel('learning_rate')
            self.textot8lr = QLineEdit()
            self.textot8lr.setText("constant;invscaling;adaptive")#para pruebas   
            self.formt8.addRow(self.titulot8lr, self.textot8lr)
            
            self.titulot8lri = QLabel('learning_rate_init')
            self.textot8lri = QLineEdit()
            self.textot8lri.setText("0.0001;1")#para pruebas   
            self.formt8.addRow(self.titulot8lri, self.textot8lri)
            
            self.combot8cs2.addItems(["MLPClassifier","Kneighbors","SVM","NaiveBayes"])
            self.clasificadorName="MLP"
            print(self.clasificadorName)
            
        #modo creacion
        self.titulot8mt = QLabel('Modo Creación')
        self.formt8.addRow(self.titulot8mt)
        
        #metrica
        self.titulot8sc = QLabel('Scoring')
        self.combot8sc = QComboBox()
        self.combot8sc.addItems(["accuracy","roc_auc"])
        self.formt8.addRow(self.titulot8sc, self.combot8sc)
        
        #metodo
        self.titulot8mtd = QLabel('Metodo')
        self.combot8mtd = QComboBox()
        self.combot8mtd.addItems(["HoldOut","ValidaciónCruzada"])
        self.formt8.addRow(self.titulot8mtd, self.combot8mtd)
        
        
        #resto botones
        self.pushButtont8op = QPushButton("Optimizar")
        self.pushButtont8op.clicked.connect(self.optimizadoButton)
        self.formt8.addRow(self.pushButtont8op)
        
        self.pushButtont8sv = QPushButton("Guardar")
        self.pushButtont8sv.clicked.connect(self.guardaModelo)
        self.textot8sv = QLineEdit()
        self.textot8sv.setText("modelo.plk")#para pruebas
        self.formt8.addRow(self.pushButtont8sv, self.textot8sv)
        
        self.titulot8rs = QLabel('LOG')
        self.resultadost8 = QPlainTextEdit('ESTADO: No Iniciado\n')
        self.resultadost8.setReadOnly(True)
        self.formt8.addRow(self.titulot8rs, self.resultadost8)
      
    #funcion que carga los parametros con la opcion parametrizar  
    def handleButtonCrearParametros(self):
        
            entrada = str(self.combot8cs2.currentText())
            numRows=self.formt8.rowCount()
            for i in range(numRows):
                self.formt8.removeRow(0)
            
            
            self.combot8cs = QComboBox(self)
            self.combot8cs.addItems(["Parametrizar","ImportarModelo","Optimizador"])
            self.pushButtont8 = QPushButton("SeleccionModo")
            self.pushButtont8.clicked.connect(self.handleButtonSeleccionModelo)
            self.formt8.addRow(self.pushButtont8, self.combot8cs)
        
            self.clasificadorTipo="Parametrizar"
            print(self.clasificadorTipo)

            self.combot8cs2 = QComboBox(self)
            self.pushButtont8 = QPushButton("SelecciónAlgoritmo")
            self.pushButtont8.clicked.connect(self.handleButtonCrearParametros)
            self.formt8.addRow(self.pushButtont8, self.combot8cs2)
            
            
            if (entrada == "NaiveBayes"):
                self.spt8ap = QDoubleSpinBox()
                self.spt8ap.setRange(0.0001,10.0)
                self.spt8ap.setDecimals(4)
                self.spt8ap.setValue(1.0)
                self.spt8ap.setSingleStep(0.01)
                self.titulot8ap = QLabel('Alpha')
                
                self.titulot8fp = QLabel('Fit_Prior')
                self.combot8fp = QComboBox(self)
                self.combot8fp.addItems(["True","False"])
                
                self.combot8cs2.addItems(["NaiveBayes","SVM","Kneighbors","MLPClassifier"])
                    
                self.formt8.addRow(self.titulot8ap, self.spt8ap)
                self.formt8.addRow(self.titulot8fp, self.combot8fp)
                
                self.clasificadorName="NB"
                print(self.clasificadorName)
                
                #self.tabs.setCurrentIndex(3)
                
            elif (entrada == "SVM"):
    
                self.spt8c = QDoubleSpinBox()
                self.spt8c.setRange(0.0001,1000.0)
                self.spt8c.setDecimals(4)
                self.spt8c.setValue(1.0)
                self.spt8c.setSingleStep(0.1)
                self.titulot8c = QLabel('C')
                
                self.titulot8dl = QLabel('dual')
                self.combot8dl = QComboBox(self)
                self.combot8dl.addItems(["True","False"])                
                self.combot8cs2.addItems(["SVM","NaiveBayes","Kneighbors","MLPClassifier"])
                    
                self.formt8.addRow(self.titulot8c, self.spt8c)
                self.formt8.addRow(self.titulot8dl, self.combot8dl)
                
                self.clasificadorName="SVM"
                print(self.clasificadorName)
                
            elif (entrada == "Kneighbors"):
                
                self.titulot8nv = QLabel('Nº Vecinos')
                self.sptt8nv = QSpinBox()
                self.sptt8nv.setRange(1,1000)
                self.sptt8nv.setSingleStep(1)
                self.formt8.addRow(self.titulot8nv, self.sptt8nv)
                
                self.combot8cs2.addItems(["Kneighbors","SVM","NaiveBayes","MLPClassifier"])
                self.clasificadorName="KN"
                print(self.clasificadorName)
            
            elif (entrada == "MLPClassifier"):
                
                self.titulot8hl = QLabel('Hidden Layers,Hidden Units')
                self.textot8hl = QLineEdit()
                self.textot8hl.setText("1,5")
                self.formt8.addRow(self.titulot8hl, self.textot8hl)
                
                self.titulot8lr = QLabel('learning_rate')
                self.combot8lr = QComboBox(self)
                self.combot8lr.addItems(["constant","invscaling","adaptive"])
                self.formt8.addRow(self.titulot8lr, self.combot8lr)
                
                self.sptt8lri = QDoubleSpinBox()
                self.sptt8lri.setRange(0.0001,10.0)
                self.sptt8lri.setDecimals(4)
                self.sptt8lri.setValue(0.001)
                self.sptt8lri.setSingleStep(0.01)
                self.titulot8lri = QLabel('learning_rate_init')
                self.formt8.addRow(self.titulot8lri, self.sptt8lri)
                
                self.sptt8am = QDoubleSpinBox()
                self.sptt8am.setRange(0.0001,10.0)
                self.sptt8am.setDecimals(4)
                self.sptt8am.setValue(1.0)
                self.sptt8am.setSingleStep(0.01)
                self.titulot8am = QLabel('Alpha')
                self.formt8.addRow(self.titulot8am, self.sptt8am)
                
                self.titulot8it = QLabel('Nº Iteraciones')
                self.sptt8it = QSpinBox()
                self.sptt8it.setRange(1,10000)
                self.sptt8it.setValue(100)
                self.sptt8it.setSingleStep(1)
                self.formt8.addRow(self.titulot8it, self.sptt8it)
                
                self.combot8cs2.addItems(["MLPClassifier","Kneighbors","SVM","NaiveBayes"])
                self.clasificadorName="MLP"
                print(self.clasificadorName)
            
            self.pushButtont8cp = QPushButton("Crear Modelo")                
            self.pushButtont8cp.clicked.connect(self.seleccionButton)
            self.formt8.addRow(self.pushButtont8cp)
            
            self.pushButtont8sv = QPushButton("Guardar")
            self.pushButtont8sv.clicked.connect(self.guardaModelo)
            self.textot8sv = QLineEdit()
            self.textot8sv.setText("modelo.plk")#para pruebas
            self.formt8.addRow(self.pushButtont8sv, self.textot8sv)
            
            self.titulot8rs = QLabel('LOG')
            self.resultadost8 = QPlainTextEdit('ESTADO: No Iniciado\n')
            self.resultadost8.setReadOnly(True)
            self.formt8.addRow(self.resultadost8)
            
            
    #funcion que carga los parametros dependiendo de la opción de evaluacion
    def handleButtonCrearParametrosClasificacion(self):
        entrada = str(self.combot6cs.currentText())
    
        numRows=self.formt6.rowCount()
        for i in range(numRows):
            self.formt6.removeRow(0)
        
        self.combot6cs = QComboBox()
        self.pushButtont6 = QPushButton("SelecciónMétodoEvaluación")
        self.pushButtont6.clicked.connect(self.handleButtonCrearParametrosClasificacion)
        self.formt6.addRow(self.pushButtont6, self.combot6cs)
        
        if entrada == "CargaTest":
            if self.modeloActual != "importado":
                self.combot6cs.addItems(["CargaTest","ValidaciónCruzada","HoldOut","ConjuntoPruebaActual"])
            else:
                self.combot6cs.addItems(["CargaTest","ConjuntoPruebaActual"])
                
            self.textot6pp = QLineEdit()
            self.textot6pp.setText("/Users/mariomatesanz/Dropbox/MASTER/TFM/Documentos/Python/Interface/preprocesados/preprocesado.csv")#para pruebas
            self.pushButtont6pp = QPushButton("Test preprocesado")
            self.pushButtont6pp.clicked.connect(self.testPreprocesado)
            self.formt6.addRow(self.pushButtont6pp, self.textot6pp)
        
            self.clasificarTipo="CargaTest"
            
        elif entrada == "ValidaciónCruzada":
            if self.modeloActual != "importado":
                self.combot6cs.addItems(["ValidaciónCruzada","CargaTest","HoldOut","ConjuntoPruebaActual"])
    
                self.titulot6cv = QLabel('Número particiones')
                self.sptt6cv = QSpinBox()
                self.sptt6cv.setRange(1,50)
                self.sptt6cv.setSingleStep(1)
                self.formt6.addRow(self.titulot6cv, self.sptt6cv)


                self.titulot6sm = QLabel('Semilla')
                self.sptt6sm = QSpinBox()
                self.sptt6sm.setRange(0,50)
                self.sptt6sm.setSingleStep(1)
                self.formt6.addRow(self.titulot6sm, self.sptt6sm)
            
                self.titulot6sc = QLabel('Scoring')
                self.combot6sc = QComboBox()
                self.combot6sc.addItems(["accuracy","roc_auc"])
                self.formt6.addRow(self.titulot6sc, self.combot6sc)
            
            
                self.clasificarTipo="ValidaciónCruzada"
        
            else:
                self.combot6cs.addItems(["CargaTest","ConjuntoPruebaActual"])
                
        elif entrada == "HoldOut":
            if self.modeloActual != "importado":
                self.combot6cs.addItems(["HoldOut","ValidaciónCruzada","CargaTest","ConjuntoPruebaActual"])
                self.titulot6ts = QLabel('Test partition %')
                self.sptt6ts = QDoubleSpinBox()
                self.sptt6ts.setRange(0.01,1.0)
                self.sptt6ts.setDecimals(2)
                self.sptt6ts.setSingleStep(0.01)
                self.clasificarTipo="HoldOut"
                self.formt6.addRow(self.titulot6ts, self.sptt6ts)
            
                self.titulot6sm = QLabel('Semilla')
                self.sptt6sm = QSpinBox()
                self.sptt6sm.setRange(0,50)
                self.sptt6sm.setSingleStep(1)
                self.formt6.addRow(self.titulot6sm, self.sptt6sm)
            
            else:
                self.combot6cs.addItems(["CargaTest","ConjuntoPruebaActual"])
         
        elif entrada == "ConjuntoPruebaActual":
            if self.modeloActual != "importado":
                self.combot6cs.addItems(["ConjuntoPruebaActual","ValidaciónCruzada","HoldOut","CargaTest"])
            else:
                self.combot6cs.addItems(["ConjuntoPruebaActual","CargaTest"])
                
            self.clasificarTipo="ConjuntoPruebaActual"
             
        self.pushButtont6cs = QPushButton("Evaluar Modelo")
        self.pushButtont6cs.clicked.connect(self.clasificacionButton)
        self.formt6.addRow(self.pushButtont6cs)
        

        self.titulot6rs = QLabel('LOG')
        self.resultadost6 = QPlainTextEdit('ESTADO: No Iniciado\n')
        self.resultadost6.setReadOnly(True)
        self.formt6.addRow(self.resultadost6)
        
        
        
        
	#Funcion para etiquetar	que se activa desde la tab5 - etiquetado		
    def etiquetadoButton(self):

        # URLs
        url_regex = re.compile(r"(http|https|ftp)://[a-zA-Z0-9\./]+")
        # Repeating letter in words replace by only 2
        rpt_regex = re.compile(r"(.)\1{1,}", re.IGNORECASE)
        def rpt_repl(match):
            return match.group(1)+match.group(1)
        #Replace @name
        hndl_regex = re.compile(r"@(\w+)")
        def hndl_repl(match):
            #return '__HNDL_' + match.group(1).upper()
            return 'username'
        # Replace Hashtags
        hash_regex = re.compile(r"#(\w+)")
        def hash_repl(match):
            #return '__HASH_'+match.group(1).upper()
            return match.group(1)

        # Emoticons   
        regex_emo_neg=re.compile(r':-[({\[]|:[({\[]|:,[({\[]|:\'[({\[]|:"[({\[]|:[({\[][({\[]')
        regex_emo_pos=re.compile(r':-[)}\]]|:[)}\]]|[({\[]:|[({\[]-:|:-D|:D|X-D|XD|xD|<3|:\*|;-[)}\]]|;[)}\]]|;-D|;D|[({\[];|[({\[]-;'
        )

        #datos
        textotweet=self.sptt5tx.value()
        posSentiment = str(self.textot5ps.text())
        negSentiment = str(self.textot5ng.text())
        
        print(str(self.textot5rt.text()))  
        twitterData = str(self.textot5rt.text())
        separador = str(self.textot5sp.text())


        def sentiment_dict(sentimentData):
            words = [] # initialize an empty dictionary
            with codecs.open(sentimentData, "r",encoding='utf-8', errors='ignore') as afinnfile:
                for line in afinnfile:
                    line = re.sub(r'[^\x00-\x7F]',' ', line)
                    line=re.sub('\r\n','',line)
                    line=re.sub('\n','',line)
                    words.append(line) # Convert the score to an integer.
            return words # Print every (term, score) pair in the dictionary

       
        self.outputEtiquetado = []
        print("Comenzando...")
        #lecturas de datos
        posWords = sentiment_dict(posSentiment)
        negWords = sentiment_dict(negSentiment)
        lineas = sc.textFile(str(twitterData))
        aux = lineas.filter(lambda x: len(x)>0 )
        aux = aux.distinct()
        aux = aux.map(lambda x: x.split(separador)[textotweet])
        #data original
        data = aux.collect()
        
        #transformaciones
        aux = aux.map(lambda x: re.sub(r'[^\x00-\x7F]',' ', x))
        aux = aux.map(lambda x:  x.lower())
        aux = aux.map(lambda x:  re.sub(url_regex,'url',x))
        aux = aux.map(lambda x:  re.sub(hndl_regex,hndl_repl,x))
        aux = aux.map(lambda x:  re.sub(hash_regex,hash_repl,x))
        aux = aux.map(lambda x:  re.sub(regex_emo_pos, ' '+"emotpos"+' ', x))
        aux = aux.map(lambda x:  re.sub(regex_emo_neg, ' '+"emotneg"+' ', x))
        aux = aux.map(lambda x:  re.sub(rpt_regex,rpt_repl,x))
        aux = aux.map(lambda x:  re.sub('[^a-z0-9 ]','',x))
        aux = aux.collect()
        
        
        ps = PorterStemmer()
        neutro = str(self.combot5bn.currentText())
        for x in range(len(data)):
           text = aux[x]
           tweet_word = word_tokenize(text)
           #sent_score is a variable which will take care of word strength / word weightage 
           sent_score = 0.0
        
           for word in tweet_word:
               if (word not in self.stopWords):
                   if word in posWords:
                       sent_score = sent_score + float(1.0)
                   elif word in negWords:
                       sent_score = sent_score + float(-1.0)
                   elif word == "emotpos":
                       sent_score = sent_score + float(1.0)
                   elif word == "emotneg":
                       sent_score = sent_score + float(-1.0)
                   else:
                       sent_score = sent_score
                    
           if float(sent_score) > 0.0:
               #print 'Positive Sentiment'
               self.outputEtiquetado.append([1,data[x]])
                                    
           elif float(sent_score) < 0.0:
               #print 'Negative Sentiment'
               self.outputEtiquetado.append([0,data[x]])
               
           #si es ternario añadiños el neutro
           else:
               if neutro == "Ternario":
                   #print 'Neutral Sentiment'
                   self.outputEtiquetado.append([2,data[x]])

        #recuento
        pos = 0
        neg = 0
        neu = 0
        for x in self.outputEtiquetado:
            if x[0] == 1: 
                pos += 1
            elif x[0]==0:
                neg += 1
            else:
                neu+=1

        print('Tweets positivos '+str(pos))
        print('Tweets negativos '+str(neg))
        print('Tweets neutros '+str(neu))
        print('Total: '+str(len(self.outputEtiquetado)))
        
        if neutro == "Ternario":
            self.resultadost5.appendPlainText("ESTADO: Etiquetado Finalizado\nTweets positivos: " +str(pos)+ "\nTweets negativos: " +str(neg)+ "\nTweets neutros: " +str(neu)+ "\nTotal: "+ str(len(self.outputEtiquetado))+"\n") 
        else:
            self.resultadost5.appendPlainText("ESTADO: Etiquetado Finalizado\nTweets positivos: " +str(pos)+ "\nTweets negativos: " +str(neg)+ "\nTotal: "+ str(len(self.outputEtiquetado))+"\n") 
            
        self.resultadost5.appendPlainText('ESTADO: Preparado para Guardar\n')
        self.guardadoEt = True
        
    
	
		
		
    #funcion de preprocesado que se activa desde la tab preprocesado
    def preprocesadoButton(self):
        if (str(self.textot1rt.text()) == ""):
            textot2ap
            self.resultadost1.appendPlainText('ESTADO: Falta Ruta\n')
            return 0
            
        print(str(self.textot1rt.text()))  
        
        lineas = sc.textFile(str(self.textot1rt.text()))

        #campo 1 sentimiento
        etiqueta=self.sptt1et.value()
        textotweet=self.sptt1ct.value()
        separador = str(self.textot1sp.text())
        
        
        lineas = lineas.filter(lambda x: len(x)>0 )
        self.corpusSent = lineas.map(lambda x: x.split(separador)[etiqueta])
        self.corpus = lineas.map(lambda x: x.split(separador)[textotweet])
        
        #funciones de procesado de twitter
        # URLs
        url_regex = re.compile(r"(http|https|ftp)://[a-zA-Z0-9\./]+")
        # Repeating letter in words replace by only 2
        rpt_regex = re.compile(r"(.)\1{1,}", re.IGNORECASE)
        def rpt_repl(match):
            return match.group(1)+match.group(1)
        hndl_regex = re.compile(r"@(\w+)")
     
        # Replace Hashtags
        hash_regex = re.compile(r"#(\w+)")
        def hash_repl(match):
            return match.group(1)

        regex_emo_neg=re.compile(r':-[({\[]|:[({\[]|:,[({\[]|:\'[({\[]|:"[({\[]|:[({\[][({\[]')
        regex_emo_pos=re.compile(r':-[)}\]]|:[)}\]]|[({\[]:|[({\[]-:|:-D|:O|:D|X-D|XD|xD|<3|:\*|;-[)}\]]|;[)}\]]|;-D|;D|[({\[];|[({\[]-;'
        )
        
        
        entradatt = str(self.combot1tt.currentText())
        entradatw = str(self.combot1tw.currentText())
        if (entradatt == "SI"):
            self.corpus = self.corpus.map(lambda x: x.lower())
            print("Normal")
            print(str(self.combot1tt.currentText()))
        
        
        if (entradatw == "SI"):
            self.corpus = self.corpus.map(lambda x: re.sub(url_regex,'',x))
            self.corpus = self.corpus.map(lambda x: re.sub(hndl_regex,'',x))
            self.corpus = self.corpus.map(lambda x: re.sub(rpt_regex,rpt_repl,x))
            self.corpus = self.corpus.map(lambda x: re.sub(hash_regex,hash_repl,x))
            self.corpus = self.corpus.map(lambda x: re.sub(regex_emo_pos, ' '+"emotpos"+' ', x))
            self.corpus = self.corpus.map(lambda x: re.sub(regex_emo_neg, ' '+"emotneg"+' ', x))
            self.corpus = self.corpus.map(lambda x: re.sub("rt",'', x))
            print("Twitter características")
            print(str(self.combot1tw.currentText()))


        self.corpus = self.corpus.map(lambda x: re.sub('[^a-z0-9 ]','',x))
        self.corpusSent = self.corpusSent.map(lambda x: int(x))
        self.corpus = self.corpus.collect()
        self.corpusSent = self.corpusSent.map(lambda x: int(x))
        self.corpusSent = self.corpusSent.collect()
        
        testPart = self.sptt1tst.value()
        self.X_train, self.X_test, self.y_train, self.y_test = train_test_split(self.corpus, self.corpusSent, test_size=testPart, random_state=33)
        

        #recuento
        pos = 0
        neg = 0
        neu = 0
        for x in self.corpusSent:
            if x == 1: 
                pos += 1
            elif x==0:
                neg += 1
            else:
                neu += 1

        print('Tweets positivos '+str(pos))
        print('Tweets negativos '+str(neg))
        print('Total: '+str(len(self.corpusSent)))
        
        
        if neu > 0 :
            self.categorias="3"
            self.resultadost1.appendPlainText("ESTADO: Etiquetado Finalizado\nTweets positivos: " +str(pos)+ "\nTweets negativos: " +str(neg)+ "\nTweets neutros: " +str(neu)+ "\nTotal: "+ str(len(self.corpusSent))+"\n") 
            
        else:
            self.categorias="2"
            self.resultadost1.appendPlainText("ESTADO: Procesado Finalizado\nTweets positivos: " +str(pos)+ "\nTweets negativos: " +str(neg)+ "\nTotal: "+ str(len(self.corpusSent))+"\n") 
            
        self.resultadost6.appendPlainText('ESTADO: Datos Preprocesados\n')
        self.resultadost8.appendPlainText('ESTADO: Datos Preprocesados\n')
        
        
        self.clasificar=True

    #funcion de optimizado de parametros
    def optimizadoButton(self):
        #GRID
        
        if self.clasificar != True:
            self.resultadost8.appendPlainText("Preprocesa primero los datos\n")
            return 0
        
        #dict para los parametros
        parameters = {}
        
        #parametros vectorizer
        listmaxdf = []
        if (str(self.textot8maxd.text()) != ""):
            for x in self.textot8maxd.text().split(";"):
                if  '.' in x:
                    listmaxdf.append(float(x))
                #elif x=="None":
                #    list1.append(None)
                else:
                    listmaxdf.append(int(x))
            parameters['vectorizer__max_df'] = listmaxdf
        
        listmindf = []
        if (str(self.textot8mind.text()) != ""):
            for x in self.textot8mind.text().split(";"):
                if  '.' in x:
                    listmindf.append(float(x))
                else:
                    listmindf.append(int(x))
            parameters['vectorizer__min_df'] = listmindf
        
        listmaxf = []
        if (str(self.textot8maxf.text()) != ""):
            for x in self.textot8maxf.text().split(";"):
                if x=="None" or x=="0":
                    listmaxf.append(None)
                else:
                    listmaxf.append(int(x))
            parameters['vectorizer__max_features'] = listmaxf
        
        listngram = []
        if (str(self.textot8ng.text()) != ""):
            for x in self.textot8ng.text().split(";"):
                listngram.append((1,int(x)))
            parameters['vectorizer__ngram_range'] = listngram
        
        liststopw = []
        if (str(self.combot8st.currentText()) == "SI"):
            liststopw.append(self.stopWords)
            liststopw.append(None)
            parameters['vectorizer__stop_words'] = liststopw
        
        listtokenizer = []
        if (str(self.combot8tk.currentText()) == "SI"):
            listtokenizer.append(stemming_tokenizer)
            listtokenizer.append(None)
            parameters['vectorizer__tokenizer'] = listtokenizer
          
          
        listidf = []
        if (str(self.combot8idf.currentText()) == "SI"):
            listidf.append(True)
            listidf.append(False)
            parameters['vectorizer__use_idf'] = listidf
        
        listutf = []
        if (str(self.combot8utf.currentText()) == "SI"):
            listutf.append(True)
            listutf.append(False)
            parameters['vectorizer__sublinear_tf'] = listutf
       
        
        #parametros segun clasificador     
        if (self.clasificadorName == "NB"):
            #parametros fit prior alpha y pipeline 
            self.optimizado = "NB" 
            listfit = []
            if (str(self.combot8fp.currentText()) == "SI"):
                listfit.append(True)
                listfit.append(False)
                parameters['classifier__fit_prior'] = listfit
            
            listalpha = []
            if (str(self.textot8ap.text()) != ""):
                for x in self.textot8ap.text().split(";"):
                    if  '.' in x:
                        listalpha.append(float(x))
                
                parameters['classifier__alpha'] = listalpha
                
            pipeline = Pipeline([
                ('vectorizer', TfidfVectorizer()),
                ('classifier', MultinomialNB()),
            ])
        elif (self.clasificadorName == "SVM"):
            self.optimizado = "SVM" 
            #parametros dual c y pipeline
            listdual = []
            if (str(self.combot8dl.currentText()) == "SI"):
                listdual.append(True)
                listdual.append(False)
                parameters['classifier__dual'] = listdual
            
            listc = []
            if (str(self.textot8c.text()) != ""):
                for x in self.textot8c.text().split(";"):
                    if  '.' in x:
                        listc.append(float(x))
                
                parameters['classifier__C'] = listc
            
            pipeline = Pipeline([
                ('vectorizer', TfidfVectorizer()),
                ('classifier', LinearSVC()),
            ])
        elif (self.clasificadorName == "KN"):
            self.optimizado = "KN" 
            #parametros n_neighbors y pipeline
          
            listnv = []
            if (str(self.textot8nv.text()) != ""):
                for x in self.textot8nv.text().split(";"):
                    if  '.' not in x:
                        listnv.append(int(x))
                
                parameters['classifier__n_neighbors'] = listnv
            
            pipeline = Pipeline([
                ('vectorizer', TfidfVectorizer()),
                ('classifier', KNeighborsClassifier()),
            ])

        elif (self.clasificadorName == "MLP"):
            self.optimizado = "MLP" 
            
            listalpha = []
            if (str(self.textot8am.text()) != ""):
                for x in self.textot8am.text().split(";"):
                    if  '.' in x:
                        listalpha.append(float(x))
                
                parameters['classifier__alpha'] = listalpha
            
            listit = []
            if (str(self.textot8it.text()) != ""):
                for x in self.textot8it.text().split(";"):
                    if  '.' not in x:
                        listit.append(int(x))
                
                parameters['classifier__max_iter'] = listit
                
 
            listhl = []
            if (str(self.textot8hl.text()) != ""):
                for x in self.textot8hl.text().split(";"):
                    numbers = x.split(",")
                    numbers = [ int(x) for x in numbers ]
                    numbers = tuple(numbers)
                    listhl.append(numbers)
                    
                parameters['classifier__hidden_layer_sizes'] = listhl
            
            
            #constant’, ‘invscaling’, ‘adaptive
            listlr = []
            if (str(self.textot8lr.text()) != ""):
                for x in self.textot8lr.text().split(";"):
                    if  x=="constant" or x=="invscaling" or x=="adaptive":
                        listlr.append(x)
                
                parameters['classifier__learning_rate'] = listlr
            
            
            listlri = []
            if (str(self.textot8lri.text()) != ""):
                for x in self.textot8lri.text().split(";"):
                    if  '.' in x:
                        listlri.append(float(x))
                
                parameters['classifier__learning_rate_init'] = listlri
            
            pipeline = Pipeline([
                ('vectorizer', TfidfVectorizer()),
                ('classifier', MLPClassifier()),
            ])
        
        # find the best parameters for both the feature extraction and the
        # classifier
        # to be standart sklearn's scorer        
        my_auc = make_scorer(custom_auc, greater_is_better=True, needs_proba=True)
         
        
        metodo=self.combot8mtd.currentText()
        sss = StratifiedShuffleSplit(n_splits=1, test_size=0.2, random_state=0)
        
        
        metrica=self.combot8sc.currentText()
        if (metrica=='roc_auc') and (self.clasificadorName == "SVM"):
            self.resultadost8.appendPlainText("SVM no soporta optimizacion por AUC")
            return 0
        elif (metrica=='roc_auc') and (self.categorias!="3"):
            if (metodo == 'HoldOut'):
                self.grid_search = GridSearchCV(pipeline, parameters, n_jobs=-1, verbose=1,scoring = my_auc,cv=sss)
            else:
                self.grid_search = GridSearchCV(pipeline, parameters, n_jobs=-1, verbose=1,scoring = my_auc,cv=3)
        elif (metrica=='accuracy'):
            if (metodo == 'HoldOut'):
                self.grid_search = GridSearchCV(pipeline, parameters, n_jobs=-1, verbose=1,cv=sss)
            else:
                self.grid_search = GridSearchCV(pipeline, parameters, n_jobs=-1, verbose=1,cv=3)
        
        elif (metrica=='roc_auc') and (self.categorias=="3"):
            self.resultadost8.appendPlainText("Clasificación a 3 categorías no soporta optimizacion por AUC")
            return 0

        print("Performing grid search...")
        print("pipeline:", [name for name, _ in pipeline.steps])
        print("parameters:")
        pprint(parameters)
        t0 = time()
        self.grid_search.fit(self.X_train, self.y_train)
        print("done in %0.4fs" % (time() - t0))
        print()

        print("Best score: %0.4f" % self.grid_search.best_score_)
        print("Best parameters set:")
        best_parameters = self.grid_search.best_estimator_.get_params()
        for param_name in sorted(parameters.keys()):
            print("\t%s: %r" % (param_name, best_parameters[param_name]))

        self.resultadost8.appendPlainText("Best score: %0.4f" % self.grid_search.best_score_)
        self.resultadost8.appendPlainText("Best parameters set:")
        
        for param_name in sorted(parameters.keys()):
            self.resultadost8.appendPlainText("     %s: %r" % (param_name, best_parameters[param_name]))
        
        self.resultadost8.appendPlainText("\n")
        self.modeloActual = "optimizado"
        print ("optimizar")
        
        numItems=self.combot6cs.count()
        for i in range(numItems):
            self.combot6cs.removeItem(0)
        self.combot6cs.addItems(["CargaTest","ValidaciónCruzada","HoldOut","ConjuntoPruebaActual"])
        
    
	#funcion que realiza las predicciones 
    def clasificacionButton(self):
        #condiciones de entrada
        
        if self.clasificar != True:
            self.resultadost6.appendPlainText("Preprocesa primero los datos\n")
            return 0
            
        if self.clasificadorTipo == "Vacio":
            self.resultadost6.appendPlainText("Selecciona primero un modo de clasificacion\n")
            return 0
        
        if self.modeloActual == "Vacio":
            self.resultadost6.appendPlainText("Genera Primero un Modelo\n")
            return 0
        
        if self.modeloActual != "importado" and self.clasificadorName == "Vacio":
                self.resultadost6.appendPlainText("Selecciona primero un clasificador\n")
                return 0
        
        
        #CLASIFICACION
        
        #metodo hold out
        def trainHoldOut(classifier, X, y):
            print('Dividiendo Datos...')
            testPart = self.sptt6ts.value()
            semilla = self.sptt6sm.value()
            X_trainP, X_testP, y_trainP, y_testP = train_test_split(X, y, test_size=testPart, random_state=semilla)
            
            print('Creando clasificador...')
            classifier.fit(X_trainP, y_trainP)
            print('Resultado intento:')
            self.resultadost6.appendPlainText('Accuracy:')
            score = classifier.score(X_testP, y_testP)
            print (score)
            
            print("Longitud test data: "+str(len(y_testP)))
            varianza = ((1-score)*score)/len(y_testP)
            desviacion=math.sqrt(varianza)
            print(desviacion)
            self.resultadost6.appendPlainText(str('%.4f'%(score))+"+-"+str('%.4f'%(desviacion)))
                        
            if self.categorias!="3":
                if self.modeloActual != "optimizado":
                    probas_ = classifier.predict_proba(X_testP)
                    # Compute ROC curve and area the curve
                    fprs, tprs, thresholds = roc_curve(y_testP, probas_[:, 1])
                    roc_auc = auc(fprs, tprs)
                    print (roc_auc)
                    self.resultadost6.appendPlainText('AUC:')
                    self.resultadost6.appendPlainText(str('%.4f'%(roc_auc))) 
                    self.resultadost6.appendPlainText('\n')
            
            return classifier
        
        #metodo score sobre test
        def test(classifier, X, y):            
            if self.clasificarTipo == "CargaTest":
                lineas = sc.textFile(str(self.textot6pp.text()))
                #campo 1 sentimiento
                lineas = lineas.filter(lambda x: len(x)>0 )
                y_testP = lineas.map(lambda x: x.split(";")[0])
                y_testP = y_testP.map(lambda x: int(x))        
                y_testP = y_testP.collect()
                X_testP = lineas.map(lambda x: x.split(";")[1])
                X_testP = X_testP.collect()
                
            elif self.clasificarTipo == "ConjuntoPruebaActual":
                X_testP = X
                y_testP = y
            
            print('Creando predicción...')
            
            if self.modeloActual == "importado":    
                self.resultadost6.appendPlainText('Score Modelo Importado:')
            elif self.modeloActual == "generado": 
                self.resultadost6.appendPlainText('Score Modelo Parametrizado:')
            elif self.modeloActual == "optimizado": 
                self.resultadost6.appendPlainText('Score Modelo Optimizado:')
                
            score = classifier.score(X_testP, y_testP)
            
        
            print (score)
        
     
            print("Longitud test data: "+str(len(y_testP)))
            varianza = ((1-score)*score)/len(y_testP)
            desviacion=math.sqrt(varianza)
            print(desviacion)            
            self.resultadost6.appendPlainText('Accuracy:')
            self.resultadost6.appendPlainText(str('%.4f'%(score))+"+-"+str('%.4f'%(desviacion)))
            
            print(self.modeloActual)
            if self.categorias!="3":
                if self.modeloActual != "optimizado":
                    probas_ = classifier.predict_proba(X_testP)
                    # Compute ROC curve and area the curve
                    fprs, tprs, thresholds = roc_curve(y_testP, probas_[:, 1])
                    roc_auc = auc(fprs, tprs)
                    print (roc_auc)
                    self.resultadost6.appendPlainText('AUC:')
                    self.resultadost6.appendPlainText(str('%.4f'%(roc_auc))) 
                    self.resultadost6.appendPlainText('\n')    
            
            
            return classifier
        
        #metodo de validacion cruzada 
        def trainCruzada(classifier, X, y):
            print('Creando clasificador...')
            cvParticiones = self.sptt6cv.value()
            if cvParticiones==1:
                self.resultadost6.appendPlainText("Selecciona más de una partición")
                return 0
            semilla = self.sptt6sm.value()
            scoring=self.combot6sc.currentText()
            if (scoring=='roc_auc') and self.categorias=="3":
                self.resultadost6.appendPlainText('AUC no soportado en clasificación a 3 categorías ')
                return 0
            cv = ShuffleSplit(n_splits=cvParticiones, random_state=semilla)
            
            #'accuracy'
            scores = cross_val_score(classifier, X, y, cv=cv,scoring=scoring)
            print (scores)
            
            if (scoring=='roc_auc'):
                self.resultadost6.appendPlainText('AUC de validación cruzada:')
                #promedio auc
                media=0.0
                for e in scores:
                    media=media+e
                media=(media/cvParticiones)
                self.resultadost6.appendPlainText(str('%.4f'%(media)))
                
            elif (scoring=='accuracy'):
                self.resultadost6.appendPlainText('Accuracy de validación cruzada:')
                
                #promedio accuracy
                media=0.0
                for e in scores:
                    media=media+e
                media=(media/cvParticiones)
                
                #calculo desviacion 
                prom=0.0
                for e in scores:
                    prom=prom+((1-e)/cvParticiones)
                suma=0.0
                for e in scores:
                    suma=suma+(((1-e)-prom)*((1-e)-prom))
                varianza=(1/(cvParticiones-1))*suma
                desviacion=math.sqrt(varianza)
                print(desviacion)
                self.resultadost6.appendPlainText(str('%.4f'%(media))+"+-"+str('%.4f'%(desviacion)))
                
                          
            
                
                
            self.resultadost6.appendPlainText('\n')      
            return classifier
        
               
        print(self.clasificadorName)
        
        #parametros comunes vectorizer
        if (self.combot4sw.currentText() == "True"):
            palabrasParada = self.stopWords
        else:
            palabrasParada = None
            
        if (self.combot4st.currentText() == "True"):
            lexematizacion = stemming_tokenizer
        else:
            lexematizacion = None
            
        valueMinDf=self.sptt4min_df.value()
        valueMaxDf=self.sptt4max_df.value()
        
        if (self.combot4idf.currentText() == "True"):
            idf = True
        else:
            idf = False
        
        if (self.combot4sb.currentText() == "True"):
            sublin = True
        else:
            sublin = False
        
        ngramas = (1,self.sptt4ng.value())
        
        
        if self.sptt4ft.value() == 0:
            maxfeatures = None
        else:
            maxfeatures = self.sptt4ng.value()

        #optimizado -> val cruzada
        if self.clasificarTipo == "ValidaciónCruzada" and self.modeloActual == "optimizado":  
            trainCruzada(self.grid_search.best_estimator_, self.X_train, self.y_train)
        #optimizado -> hold out
        elif self.clasificarTipo == "HoldOut" and self.modeloActual == "optimizado":  
            trainHoldOut(self.grid_search.best_estimator_, self.X_train, self.y_train)
            
    
        #si el tipo de evaluacion es cruzada o hold aout hay que generar modelos d enuevo -> parametrizacion
        elif self.clasificarTipo == "ValidaciónCruzada" or self.clasificarTipo == "HoldOut" :
            if self.modeloActual != "importado" and self.modeloActual != "optimizado":
                #seleccion del clasificador segun seleccion campo clasificadorName
                if (self.clasificadorName == "NB"):
                    #parametros
                    valueAlpha=self.spt8ap.value()
                    if (self.combot8fp.currentText() == "True"):
                        prioridadEntreno = True
                    else:
                        prioridadEntreno = False
            
                    pipeline = Pipeline([
                        ('vectorizer', TfidfVectorizer(tokenizer=lexematizacion,min_df=valueMinDf, 
                                                max_df = valueMaxDf, sublinear_tf=sublin, use_idf =idf,stop_words=palabrasParada,
                                                   analyzer='word',ngram_range=ngramas,max_features=maxfeatures)),
                        ('classifier', MultinomialNB(alpha=valueAlpha,fit_prior=prioridadEntreno)),
                    ])
            
                    print('Clasificador NaiveBayes: ')
                    self.resultadost6.appendPlainText('Clasificador NaiveBayes: ')
            
                elif (self.clasificadorName == "SVM"):
                    valueC=self.spt8c.value()            
                    if (self.combot8dl.currentText() == "True"):
                        dualState = True
                    else:
                        dualState = False
                            
                    pipeline = Pipeline([
                        ('vectorizer', TfidfVectorizer(tokenizer=lexematizacion,min_df=valueMinDf, 
                                                max_df = valueMaxDf, sublinear_tf=sublin, use_idf =idf,stop_words=palabrasParada,
                                                   analyzer='word',ngram_range=ngramas,max_features=maxfeatures)),
                        ('classifier', CalibratedClassifierCV(LinearSVC(dual=dualState,C=valueC))),
                    ])
                    #llamadas ala funcion general
                    print('Clasificador SVM: ')
                    self.resultadost6.appendPlainText('Clasificador SVM: ')
            
                elif (self.clasificadorName == "KN"):
            
                    valueNv=self.sptt8nv.value()
                    pipeline = Pipeline([
                        ('vectorizer', TfidfVectorizer(tokenizer=lexematizacion,min_df=valueMinDf, 
                                                max_df = valueMaxDf, sublinear_tf=sublin, use_idf =idf,stop_words=palabrasParada,
                                                   analyzer='word',ngram_range=ngramas,max_features=maxfeatures)),
                        ('classifier', KNeighborsClassifier(n_neighbors=valueNv, algorithm='brute', metric='cosine')),
                    ])
                    print('Clasificador KNeightbors: ')
                    self.resultadost6.appendPlainText('Clasificador KNeightbors: ')
         
                elif (self.clasificadorName == "MLP"):
                     alphaMLP=self.sptt8am.value()
                     numIter=self.sptt8it.value()
                     learRateIni=self.sptt8lri.value()
                     
                     #constant’, ‘invscaling’, ‘adaptive
                     learningRate = self.combot8lr.currentText()
                     
                     if (str(self.textot8hl.text()) != ""):
                        numbers = self.textot8hl.text().split(",")
                        numbers = [ int(x) for x in numbers ]
                        numbers = tuple(numbers)
                     
                     pipeline = Pipeline([
                         ('vectorizer', TfidfVectorizer(tokenizer=lexematizacion,min_df=valueMinDf, 
                                                 max_df = valueMaxDf, sublinear_tf=sublin, use_idf =idf,stop_words=palabrasParada,
                                                    analyzer='word',ngram_range=ngramas,max_features=maxfeatures)),
                         ('classifier', MLPClassifier(hidden_layer_sizes=numbers,max_iter=numIter,
                         alpha=alphaMLP,learning_rate=learningRate,learning_rate_init=learRateIni)),
                     ])
                     print('Clasificador MLPClassifier: ')
                     self.resultadost6.appendPlainText('Clasificador MLPClassifier: ')
         
         
         
                #funcion de generacion del modelo
                if self.clasificarTipo == "ValidaciónCruzada": 
                        trainCruzada(pipeline, self.X_train, self.y_train)
                    
                elif self.clasificarTipo == "HoldOut" :
                    trainHoldOut(pipeline, self.X_train, self.y_train)
                
            elif self.modeloActual == "importado":
               self.resultadost6.appendPlainText('ESTADO: Opcion No Disponible para Importado')
        
        #sino no hay que generar modelos solo predecir-> todos   
        elif self.clasificarTipo == "CargaTest" or self.clasificarTipo == "ConjuntoPruebaActual":
            if self.modeloActual == "importado":    
                test(self.pipelineImport, self.X_test, self.y_test) 
            elif self.modeloActual == "generado": 
                test(self.modelo, self.X_test, self.y_test) 
            elif self.modeloActual == "optimizado": 
                test(self.grid_search, self.X_test, self.y_test) 
                print("optimizando test")
          
        
    #opcion de importar un modelo
    def importarModeloClasificacion(self):
        rutaModelo = self.textot8im.text()
        from sklearn.externals import joblib
        self.pipelineImport = joblib.load(rutaModelo)
        self.resultadost8.appendPlainText('ESTADO: Modelo Cargado')
        
        numItems=self.combot6cs.count()
        for i in range(numItems):
            self.combot6cs.removeItem(0)
        self.combot6cs.addItems(["CargaTest","ConjuntoPruebaActual"])
        
        self.modeloActual = "importado"
        
    #funcion de generacion de modelos
    def seleccionButton(self):
        #conjunto de palabras de parada
        
        if self.clasificar != True:
            self.resultadost8.appendPlainText("Preprocesa primero los datos\n")
            return 0
            
        if self.clasificadorTipo == "Vacio":
            self.resultadost8.appendPlainText("Selecciona primero un modo de clasificacion\n")
            return 0
            
        if self.clasificadorName == "Vacio":
            self.resultadost8.appendPlainText("Selecciona primero un clasificador\n")
            return 0
         
        #CLASIFICACION
        #primero genera los datos train test

        #generar el modelo
        def train(classifier, X, y):
            
            classifier.fit(X, y)    
            print('Modelo Generado')
            self.resultadost8.appendPlainText('ESTADO: Modelo Generado')
            self.modeloActual = "generado"
            
            numItems=self.combot6cs.count()
            for i in range(numItems):
                self.combot6cs.removeItem(0)
            self.combot6cs.addItems(["ConjuntoPruebaActual","CargaTest","ValidaciónCruzada","HoldOut"])
            
            return classifier
            
        
               
        print(self.clasificadorName)
    
        #parametros comunes vectorizer
        if (self.combot4sw.currentText() == "True"):
            palabrasParada = self.stopWords
        else:
            palabrasParada = None
        
        if (self.combot4st.currentText() == "True"):
            lexematizacion = stemming_tokenizer
        else:
            lexematizacion = None
        
        valueMinDf=self.sptt4min_df.value()
        valueMaxDf=self.sptt4max_df.value()
    
        if (self.combot4idf.currentText() == "True"):
            idf = True
        else:
            idf = False
    
        if (self.combot4sb.currentText() == "True"):
            sublin = True
        else:
            sublin = False
        #print(valueMinDf)
        #print(valueMaxDf)
    
        ngramas = (1,self.sptt4ng.value())
    
    
        if self.sptt4ft.value() == 0:
            maxfeatures = None
        else:
            maxfeatures = self.sptt4ng.value()


    
        #seleccion del clasificador segun seleccion campo clasificadorName
        if (self.clasificadorName == "NB"):
            #parametros
            valueAlpha=self.spt8ap.value()
            if (self.combot8fp.currentText() == "True"):
                prioridadEntreno = True
            else:
                prioridadEntreno = False
        
            pipeline = Pipeline([
                ('vectorizer', TfidfVectorizer(tokenizer=lexematizacion,min_df=valueMinDf, 
                                        max_df = valueMaxDf, sublinear_tf=sublin, use_idf =idf,stop_words=palabrasParada,
                                           analyzer='word',ngram_range=ngramas,max_features=maxfeatures)),
                ('classifier', MultinomialNB(alpha=valueAlpha,fit_prior=prioridadEntreno)),
            ])
        
            #llamadas ala funcion general
            print('Clasificador NaiveBayes: ')
            self.resultadost8.appendPlainText('Clasificador NaiveBayes: ')
        
        

        elif (self.clasificadorName == "SVM"):
        
            valueC=self.spt8c.value()
            #print(self.combot3dl.currentText())
        
            if (self.combot8dl.currentText() == "True"):
                dualState = True
            else:
                dualState = False
                        
            pipeline = Pipeline([
                ('vectorizer', TfidfVectorizer(tokenizer=lexematizacion,min_df=valueMinDf, 
                                        max_df = valueMaxDf, sublinear_tf=sublin, use_idf =idf,stop_words=palabrasParada,
                                           analyzer='word',ngram_range=ngramas,max_features=maxfeatures)),
                ('classifier', CalibratedClassifierCV(LinearSVC(dual=dualState,C=valueC))),
            ])
            #llamadas ala funcion general
            print('Clasificador SVM: ')
            self.resultadost8.appendPlainText('Clasificador SVM: ')
        
        elif (self.clasificadorName == "KN"):
        
            valueNv=self.sptt8nv.value()
         
            pipeline = Pipeline([
                ('vectorizer', TfidfVectorizer(tokenizer=lexematizacion,min_df=valueMinDf, 
                                        max_df = valueMaxDf, sublinear_tf=sublin, use_idf =idf,stop_words=palabrasParada,
                                           analyzer='word',ngram_range=ngramas,max_features=maxfeatures)),
                ('classifier', KNeighborsClassifier(n_neighbors=valueNv, algorithm='brute', metric='cosine')),
            ])
            #llamadas ala funcion general
            print('Clasificador KNeightbors: ')
            self.resultadost8.appendPlainText('Clasificador KNeightbors: ')
     
     
        elif (self.clasificadorName == "MLP"):
             alphaMLP=self.sptt8am.value()
             numIter=self.sptt8it.value()
             learRateIni=self.sptt8lri.value()
             
             #constant’, ‘invscaling’, ‘adaptive
             learningRate = self.combot8lr.currentText()
             
             if (str(self.textot8hl.text()) != ""):
                numbers = self.textot8hl.text().split(",")
                numbers = [ int(x) for x in numbers ]
                numbers = tuple(numbers)
             
             pipeline = Pipeline([
                 ('vectorizer', TfidfVectorizer(tokenizer=lexematizacion,min_df=valueMinDf, 
                                         max_df = valueMaxDf, sublinear_tf=sublin, use_idf =idf,stop_words=palabrasParada,
                                            analyzer='word',ngram_range=ngramas,max_features=maxfeatures)),
                 ('classifier', MLPClassifier(hidden_layer_sizes=numbers,max_iter=numIter,
                 alpha=alphaMLP,learning_rate=learningRate,learning_rate_init=learRateIni)),
             ])
             #llamadas ala funcion general
             print('Clasificador MLPClassifier: ')
             self.resultadost8.appendPlainText('Clasificador MLPClassifier: ')
     
        #validacion cruzada o solo una particion
        self.modelo = train(pipeline, self.X_train, self.y_train)
            
        
#general
if __name__ == '__main__':
    #spark sc
    sc = SparkContext()
     
	#funcion que tokeniza y steemiza
    def stemming_tokenizer(text):
        stemmer = PorterStemmer()
        return [stemmer.stem(w) for w in word_tokenize(text)]
	
    #para el calculo del auc en optimizar
    def custom_auc(ground_truth, predictions):
         # I need only one column of predictions["0" and "1"]. You can get an error here
         # while trying to return both columns at once
         fpr, tpr, _ = roc_curve(ground_truth, predictions[:, 1], pos_label=1)    
         return auc(fpr, tpr)	
		
		
    app = QApplication(sys.argv)
    ex = App()
    sys.exit(app.exec_())